/**************************************************************/
/*                                                            */
/*   Program Name :  autoobs_s                                */
/*                                                            */
/*      Version:  1.00  2003-06-17                            */
/*                                                            */
/*      Copyright (c) 2003 T.Kondo/CRL All Right Reserved     */
/*                                                            */
/**************************************************************/
#include <stdio.h>
#include <signal.h> 
#include <errno.h>
#include <fcntl.h>
//#include <unistd.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <sys/stat.h>
#ifdef linux
#include <sys/time.h>
#else
#include <time.h>
#endif
//#include <sys/tdsio.h>

#ifndef WIN32
#include <unistd.h>
#include <sys/tdsio.h>
#endif

#include "libipvlbi.h"  // IP-VLBIp֐Q(by T.Kondo)
#ifndef WIN32
#include "libipvlbi_board.h"  // IP-VLBITv[{[hp֐Q(by T.Kondo)
#endif

#define SLEEP_USEC 10000    // watch dog timer sep (10msec)

#define GET_TIME_FROM_BOARD 1  //  ^p̎{[h瓾邩ob̎瓾邩̔
	                      //  1: {[h    0:ob
#define LOGFILE_TYPE 0   // log file name type
                         //  0: exocode+station_id+"."+hostname+".log"
                         //  1: YYYY+hostname+".log"
                         //       where  YYYY is 4 digit year

/*
ho|ukah@ItCϑvO(2000ϑ̃T|[gj
        iZbg͕ʂ̃\tgōsj
         by T.Kondo 2002.3.13

        uNOZOMIvϑpɓautoobs2ŁuNOZOMIvϑ
               Pch[hAϑ͂Sch[hɎIɐ؂ւAfBXNeʂ
               ߖsB
               ӁF1chTv[{[hɂ4chTv[{[hch1ƓrfIM
               ͂邱ƁI


    点@autoobs_s sked_file station_id [span [sfreq [adbit [numch [outdir]]]]]
         Ł@sked_file ---- XPW[t@C
                staion_id ----  ID (XPW[t@CŋLqĂǂhc)
                span ---- ϑ (sec)
                          iXPW[t@CŋK肵Ă
                           ϑԂZړIj
                           ftHg͂POb
                           XPW[t@Cʂ̊ϑԂƂƂ
                           OƂ
                sfreq  TvOg
                       40,100,200,500  (kHz)
                       1,2,4,8,16      (MHz)
                          ftHg16
                adbit  `c\irbg)
                       1,2,4,8
                          ftHg1
                numch  `l
                       1@܂ 4
                          ftHg1
                outdir  f[^t@Co̓fBNg
                          ftHg̓JgfBNg
*/


// global variables
char logdir[60];               // logfile directory
char hostname[20];             // host name
char logfile[80];              //log file name
int logfiletype=LOGFILE_TYPE;  // logfile name type

typedef struct listoutdir    
{            
    int  dirnum;
    char dir[10][80];
} listoutdir_t;

/* set interrupt handler */
void Handler(int n);

void SetHandler(void)
{
    if(signal(SIGINT, Handler) == SIG_ERR){
        printf("Signal handler set up failure!\n");
        abort();
    }
}

void Handler(int n)
{
     //static int x=0;
     char cbuf[80];
     printf("\n\n Interrupt occurred !!\n");
     sprintf(cbuf,"Interrupt occurred !!  AUTOOBS_S OBSERVATION TERMINATED by OPERATOR");
     LogWrite3(logdir,hostname,logfile,logfiletype,0,0.0,3,cbuf);
     exit(0);
}

void get_outdir(char* k5outinfo, listoutdir_t *outdirtab)
//void get_outdir(char* k5outinfo, int *dirnum)
//void get_outdir(char* k5outinfo, char** outdirtab, int *dirnum)
{
       int i;
       char line[100];
       FILE *stream;

       if( (stream  = fopen( k5outinfo, "r" )) == NULL ){
          printf("get_outdir: File (%s) not found or Open Error! \n",k5outinfo);
          goto exitend2;
       }

  loop1:

       if( fgets( line, 100, stream ) == NULL){
          //printf("File EOF or Read Error!\n");
          goto exitend;
       }
       printf("%s",line);
       if(line[0]=='*') {  
          goto loop1;  // this is comment line (nothing to do)  
       } else {
          /* remove CR code */
          i=strlen(line);
          line[i-1]='\0';
          /* check last character */
          i=strlen(line);
          if(line[i-1] != '/') {
             line[i]='/';
             line[i+1]='\0';
          }
          //printf("dirnum = %d\n",outdirtab->dirnum);
          strcpy(outdirtab->dir[outdirtab->dirnum],line);
          outdirtab->dirnum++;
       }
       goto loop1;
  exitend:
       i=fclose(stream);
  exitend2:;
}



int main(int argc, char *argv[])
{
       char dev[] = "/dev/tds0";
       char outfile [80];
       char fname [50];
       char outdir [80];
       char* dflt_dir="./";           // default out file directory (1st)
       char* dflt_k5outinfo="k5outinfo.txt";  // default out directories 2nd(1st), 3rd(2nd),....
       char* dflt_logdir="./";        // default log file directory
       char skdname[80];
       char mystation[11];
       char stat_id[4];
       char cbuf[120];
       char afreq[20];
       char y_or_n[2];
       char k5outinfo[80];            // file contains out directories
       char* keyword="NOZ";          // key word for 1ch mode (source name)
       //char logdir[60];               // logfile directory
       //char hostname[20];             // host name
       //char logfile[80];             // host name
       int ndir;                     //current directory number 
       int fd_in,rv;
       int i, span, sfreq, adbit, numch;
       int nobs, obsspan, fixspan;  
       int year,ddd,hh,mm,ss ;
       int yearf,dddf,hhf,mmf,ssf ;   // to keep 1st obs info
       int yearl,dddl,hhl,mml,ssl ;   // to keep last obs info
       int year1,ddd1,hh1,mm1,ss1 ;   // 
       int year2,ddd2,hh2,mm2,ss2 ;   // 
       int yearn,dddn,hhn,mmn,ssn ;
       int yearPC;  // to keep yaer get from PC
       int month,mday;
       int monthf,mdayf;
       int monthl,mdayl;
       int month1,mday1;
       int month2,mday2;
       int monthn,mdayn;
       int iofset;
       int flagobs;
       unsigned int time,day,sec; // foCXǂݍ񂾌݂̎i[
       unsigned int secold, sec1st, seclast, secobsst, secobset, secnow, secnext;
       int day1st, daylast, daynow, daynext;
       int  h, m, s;          
       int counter;
       int time_mode;  // ^p̎{[h瓾邩ob̎瓾邩̔
                       //  0: {[h@@@1:ob
       float timeoffset;  //  PCI board time - CPU time label (in sec)
       float tofset, fsec;
       float w1,w2,w3,w4,w5 ;  // work
       double dtime1st,dtimelast,dtimenow, dtimenext, dtimenext2;
       double dtime1, dtime2;  // manually set obs time range
       double d1sec;    // 1sec in day unit
       double dwork;
       double freeb, freeb2, reqb, reqmb, dsfreq;
       listoutdir_t outdirtab;
       static sked_data_t skd;
       d1sec=1.0/86400.0;
       if(argc == 1){
          printf("autoobs_s Ver.1.00\n");
          printf("Usage: autoobs_s sked_file station_id [span [sfreq [adbit [numch [outdir [y_or_no]]]]]]\n");
          printf("\n");
          printf("         where  sked_file ---- schedule file name\n");
          printf("                staion_id ---- station ID (A1)\n");
          printf("                span ---- duration (sec)\n");
          printf("                          compulsory shorten obs length!\n");
          printf("                          default = 10 (sec)\n");
          printf("                          =0 means no effect\n");
          printf("                sfreq ---- sampling frequency\n");
          printf("                           40,100,200,500 (for kHz)\n");
          printf("                           1,2,4,8,16 (for MHz)\n");
          printf("                          default is 16\n");
          printf("                adbit ---- A/D bit\n");
          printf("                           1,2,4,8\n");
          printf("                          default is 1\n");
          printf("                numch ---- number of channel\n");
          printf("                           1,4\n");
          printf("                          default is 1\n");
          printf("                outdir ---- output file directory\n");
          printf("                          default is current directory\n");
          printf("                y_or_n ---- Obs range limitation reply N or Y\n");
          printf("                          default is interactively asked later\n");
          exit(0);
       }

       if (argc>=2){
          strcpy(skdname,argv[1]);  
       }

       if (argc>=3){
          strcpy(stat_id,argv[2]);  
       } else {
          strcpy(stat_id,"G");   // default set to KOGANEI
       }

       if (argc>=4){
           fixspan = atoi(*(argv + 3 ));
       } else {
          fixspan=10;   // default fix span (sec)
       }

       if (argc>=5){
           sfreq = atoi(*(argv + 4 ));
       } else {
          sfreq=16;
       }

       if (argc>=6){
           adbit = atoi(*(argv + 5 ));
       } else {
          adbit=1;
       }

       if (argc>=7){
          numch = atoi(*(argv + 6 ));
       } else {
          numch=1;
       }

       if (argc>=8){
          strcpy(outdir,*(argv+7));
       } else {
          strcpy(outdir,dflt_dir);
       }
       /* check out dir name accompanied by "/" or not */
       i=strlen(outdir);
       //printf("i= %d\n",i);
       if(outdir[i-1] != '/') {
          outdir[i]='/';
          outdir[i+1]='\0';
       }
       
       for(i=0; i<10; i++){
          strcpy(outdirtab.dir[i],"NONE");
       }
       
       strcpy(outdirtab.dir[0],outdir);
       outdirtab.dirnum=1;

       if (argc>=9)
       {
          strcpy(y_or_n,*(argv+8));
       }
       else
       {
          strcpy(y_or_n," ");
       }

       /* log directory name get from enviroment variable K5LOGDIR if it is set */
       if(getenv("K5LOGDIR") != NULL){
          strcpy(logdir,getenv("K5LOGDIR"));
       } else {
          strcpy(logdir,dflt_logdir);
       }

       /* get file name that contains 2nd, 3rd, 4th, ... directory candidate for output */
       if(getenv("K5OUTINFO") != NULL){
          strcpy(k5outinfo,getenv("K5OUTINFO"));
       } else {
          strcpy(k5outinfo,dflt_k5outinfo);
       }
       get_outdir(k5outinfo, &outdirtab);
       //get_outdir(k5outinfo, &dirnum);
       for(i=0; i<outdirtab.dirnum; i++){
          printf("%d  %s\n",i,outdirtab.dir[i]);
       }
       
       /* get host name */
       hostget(hostname);

       time_mode=GET_TIME_FROM_BOARD;  //  current TIME get from IP-VLBI board or not
       //time_mode=0;  //  current TIME get from PC board

       printf(" skedname = %s\n",skdname);    // debug
       printf(" station_id = %s\n",stat_id);    // debug
       printf(" span = %d\n",fixspan);    // debug
       printf(" sfreq= %d\n",sfreq);   // debug
       printf(" adbit= %d\n",adbit);   // debug
       printf(" numch= %d\n",numch);   // debug
       printf(" outdir= %s\n",outdir);   // debug
       if(sfreq==40){ strcpy(afreq,"40kHz");}
       else if(sfreq==100){ strcpy(afreq,"100kHz");}
       else if(sfreq==200){ strcpy(afreq,"200kHz");}
       else if(sfreq==500){ strcpy(afreq,"500kHz");}
       else if(sfreq==1){ strcpy(afreq,"1MHz");}
       else if(sfreq==2){ strcpy(afreq,"2MHz");}
       else if(sfreq==4){ strcpy(afreq,"4MHz");}
       else if(sfreq==8){ strcpy(afreq,"8MHz");}
       else if(sfreq==16){ strcpy(afreq,"16MHz");}
       else { strcpy(afreq,"INVALID");}
	
	   if(sfreq < 40){
	      dsfreq=(double)sfreq*1.0e6;
	   } else {
	      dsfreq=(double)sfreq*1.0e3;
	   }

       /* schedule file read and analysis */

       readskd(skdname, &skd);
       if (skd.nobs <= 0)  { goto exitend ; }

       /* Observation Time Range Check */
       yearf=skd.start[0][0]+2000;
       dddf=skd.start[0][1];
       hhf=skd.start[0][2];
       mmf=skd.start[0][3];
       ssf=skd.start[0][4];
       sec1st=hhf*3600+mmf*60+ssf;
       day1st=dddf;
       printf("day1st  %d\n",day1st);
       dtime1st=day1st+sec1st/86400.0;
       ddd2md(yearf,dddf,&monthf,&mdayf);
       printf("1st  Obseravtion : %04d/%02d/%02d %02d:%02d:%02d  %s\n",yearf,monthf,mdayf,hhf,mmf,ssf,
                      skd.obsstar[0]);
       yearl=skd.start[skd.nobs-1][0]+2000;
       dddl=skd.start[skd.nobs-1][1];
       hhl=skd.start[skd.nobs-1][2];
       mml=skd.start[skd.nobs-1][3];
       ssl=skd.start[skd.nobs-1][4];
       seclast=hhl*3600+mml*60+ssl;
       daylast=dddl;
       dtimelast=daylast+seclast/86400.0;
       ddd2md(yearl,dddl,&monthl,&mdayl);
       printf("Last Obseravtion : %04d/%02d/%02d %02d:%02d:%02d  %s\n",yearl,monthl,mdayl,hhl,mml,ssl,
                      skd.obsstar[skd.nobs-1]);
       // printf("Date range %f -- %f\n",dtime1st,dtimelast);

       dtime1=dtime1st;     dtime2=dtimelast;
       year1=yearf;       year2=yearl;
       ddd1=dddf;       ddd2=dddl;
       month1=monthf;   month2=monthl;
       mday1=mdayf;     mday2=mdayl;
       hh1=hhf;        hh2=hhl;
       mm1=mmf;        mm2=mml;
       ss1=ssf;        ss2=ssl;
       /* Observation range limit if selected so */

       if (strncmp(y_or_n," ",1)==0) { // interactive mode
       strcpy(cbuf,"\0");
       //printf(" Observation Time range Change? (Y/[N]) ----> ");
       printf(" Observation Time range Change? (Y/N) ----> ");
       scanf("%s",&cbuf);
       if(strncmp(cbuf,"Y",1)==0 || strncmp(cbuf,"y",1)==0 ){
            year1=yearf;
            printf("Enter Start Time (month mday hour min sec)\n");
            scanf("%d %d %d %d %d", &month1,&mday1,&hh1,&mm1,&ss1);
            md2ddd(year1,&ddd1,month1,mday1);
            secnow=hh1*3600+mm1*60+ss1;
            dtime1=(double)ddd1+secnow/86400.0;
            printf("Enter Stop  Time (month mday hour min sec)\n");
            scanf("%d %d %d %d %d", &month2,&mday2,&hh2,&mm2,&ss2);
            md2ddd(year1,&ddd2,month2,mday2);
            secnow=hh2*3600+mm2*60+ss2;
            dtime2=(double)ddd2+secnow/86400.0;
            printf("dtime1 dtime2 %f %f\n)",dtime1,dtime2);
       }
       } else if(strncmp(y_or_n,"Y",1)==0){
            year1=yearf;
            printf("Enter Start Time (month mday hour min sec)\n");
            scanf("%d %d %d %d %d", &month1,&mday1,&hh1,&mm1,&ss1);
            md2ddd(year1,&ddd1,month1,mday1);
            secnow=hh1*3600+mm1*60+ss1;
            dtime1=(double)ddd1+secnow/86400.0;
            printf("Enter Stop  Time (month mday hour min sec)\n");
            scanf("%d %d %d %d %d", &month2,&mday2,&hh2,&mm2,&ss2);
            md2ddd(year1,&ddd2,month2,mday2);
            secnow=hh2*3600+mm2*60+ss2;
            dtime2=(double)ddd2+secnow/86400.0;
            printf("dtime1 dtime2 %f %f\n)",dtime1,dtime2);
       }
       	    


       /* station select if Station is not yet selected */

       if (argc<=2)
       {
          printf(" ****** STATION ID TABLE *********\n");
          for (i=0; i<skd.nstation ; i++)
          {
             printf("  %s --- %s\n",skd.statid[i],skd.statnam[i]);
          }
          printf(" *********************************\n");
          printf(" Enter Station ID ----> ");
          scanf("%s",&stat_id);
          printf(" Selected station_id is %s\n",stat_id);
       }
       /* Set Up my station Name */
       strcpy(mystation,"\0");
       for (i=0; i<skd.nstation ; i++)
       {
           if (strncmp(skd.statid[i],stat_id,1)==0)
           {
                //strncpy(mystation,skd.statnam[i],strlen(skd.statnam[i]));
                strcpy(mystation,skd.statnam[i]);
                printf("  %s --- %s\n",stat_id,mystation);
           }
       }


       /* log file name create */

       i=strlen(logdir);
       if (logdir[i-1] != '/'){
           logdir[i]='/';
           logdir[i+1]='\0';
       } 
       sprintf(logfile,"%s%s%s.%s.log",logdir,skd.expcode,stat_id,hostname);

       /* log start */
       sprintf(cbuf,"*********** AUTOOBS_S Ver 1.00 START **************");
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf," skedname = %s",skdname); 
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf," station_id = %s",stat_id); 
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf," span = %d",fixspan);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf," sfreq= %s",afreq);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf," adbit= %d",adbit);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf," numch= %d",numch);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf," outinfo= %s",k5outinfo); 
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       //sprintf(cbuf," 1st outdir= %s",outdir); 
       //LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       for(i=0; i< outdirtab.dirnum; i++){
            sprintf(cbuf,"  outdir candidate :  %s",outdirtab.dir[i]); 
            LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       }
       sprintf(cbuf,"***************************************************");
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
	
	   SetHandler();   // Interrapt handler



        /* Board Time and System Time Check and offset get */
        iofset=0;
        tofset=0.0;
 
        fd_in = open("/dev/tds0", O_RDONLY);  //foCX̃I[v
        if (fd_in == -1) {
            perror("device open() error ");
            return -1;
        }
        //foCX玞̎擾 and display while
        secold=100000;
        counter=0;

        do{
           rv = ioctl(fd_in, TDSIO_GET_TIME, &time);
           if (rv == -1) 
           {
              perror("ioctl() time get failed ");
              return -1;
           }
           day=TDS_GET_DAYS(time);
           sec=TDS_GET_SEC(time);
           if (sec!=secold)        // to catch exact second tic
           {
              sec2hms(sec,&h,&m,&s);
              printf("%03d %02d:%02d:%02d\n",day,h,m,s);
              if (counter >=1 ) { goto exith1 ;}
              counter++; 
           }
           secold=sec;
        }while(counter <=10);
        exith1:

        //iofset=0;
        //tofset=0.0;
        //getsystime(&year, &month, &mday, &hh, &mm, &ss, &iofset);
        getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset);
        tofset=(float)sec-((float)(hh*3600+mm*60+ss)+fsec); 
        //iofset=sec-(hh*3600+mm*60+ss);
        printf("System Time : %04d/%02d/%02d %02d:%02d:%02d\n",year,month,mday,hh,mm,ss);
        printf("Offset %f\n",tofset);
        yearPC=year;  // year info get from PC save
        //printf("Offset %d\n",iofset);

        close(fd_in);  // ho|ukah{[hN[Y
        
        
        ndir=0;
        strcpy(outdir,outdirtab.dir[ndir]);
        ndir++;
        
        /* log obs range info */
       freeb=GetFreeInfo(outdir);
       if(strncmp(outdirtab.dir[ndir],"NONE",4)==0){
          freeb2=0.0;
       } else {
          freeb2=GetFreeInfo(outdirtab.dir[ndir]);
       }
       sprintf(cbuf,"*****************************************************************");
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"*                                                               *");
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"*  AUTOOBS_S (Automatic observation program for IP-VLBI board)  *");
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"*            (Ver 1.00    2003-06-16   T.Kondo/CRL)             *");
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"*                                                               *");
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       if(time_mode==1){
       sprintf(cbuf,"*         Time for scheduling Get from IP-Board                 *");
       } else {
       sprintf(cbuf,"*         Time for scheduling Get from PC                       *");
       }
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"*****************************************************************");
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"  Schedule File     :  %s",skdname);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"  Experiment Code   :  %s",skd.expcode);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"  Log File          :  %s",logfile);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"  Sampling Frequency:  %s,  AD bits: %d,   # of CH: %d",afreq, adbit, numch);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"  Stations Included :  %s",skd.statnam[0]);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       for (i=1; i<skd.nstation; i++){ 
       sprintf(cbuf,"                    :  %s",skd.statnam[i]); 
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       }
       sprintf(cbuf,"  My Station Name   :  %s (My Station ID : %s)",mystation,stat_id);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"  Current Out Dir   :  %s    %.1fMB left",outdir,freeb/1.0e6);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"  Next    Out Dir   :  %s    %.1fMB left",outdirtab.dir[ndir],freeb2/1.0e6);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"  Total Scan Number :  %d",skd.nobs);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);

       sprintf(cbuf,"  1st Scan          :  %04d/%02d/%02d %02d:%02d:%02d  (%3dsec)  %s",
                      yearf,monthf,mdayf,hhf,mmf,ssf,skd.dura[0],skd.obsstar[0]);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"  Last Scan         :  %04d/%02d/%02d %02d:%02d:%02d  (%3dsec)  %s",
                      yearl,monthl,mdayl,hhl,mml,ssl,skd.dura[skd.nobs-1],skd.obsstar[skd.nobs-1]);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);

       sprintf(cbuf,"  Obs Range (start) :  %04d/%02d/%02d %02d:%02d:%02d",
                      year1,month1,mday1,hh1,mm1,ss1);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
       sprintf(cbuf,"  Obs Range (end)   :  %04d/%02d/%02d %02d:%02d:%02d",
                      year2,month2,mday2,hh2,mm2,ss2);
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);


        /* Schedule Time Check */
        /* wait till next obs */
       
        nobs=0;

 obsloop:
       secold=90000;
       freeb=GetFreeInfo(outdir);
       if(strncmp(outdirtab.dir[ndir],"NONE",4)==0){
          freeb2=0.0;
       } else {
          freeb2=GetFreeInfo(outdirtab.dir[ndir]);
       }

       printf("\033[2J");   //  Erase the screen ( move the cursor to home ) for VT100
       printf("\033[H");   //  move the cursor to home
       printf("*****************************************************************\n");
       //printf("*                                                               *\n");
       printf("*        AUTOOBS_S (Ver 1.00    2003-06-16   T.Kondo/CRL)       *\n");
       printf("*                                                               *\n");
       if(time_mode==1){
       printf("*         Time for scheduling Get from IP-Board                 *\n");
       } else {
       printf("*         Time for scheduling Get from PC                       *\n");
       }
       printf("*****************************************************************\n");
       printf("\n");

       printf("  Schedule File     :  %s\n",skdname);
       printf("  Experiment Code   :  %s\n",skd.expcode);
       printf("  Log File          :  %s\n",logfile);
       printf("  Sampling Frequency:  %s,  AD bits: %d,   # of CH: %d\n",afreq, adbit, numch);
       printf("  Stations Included :  %s",skd.statnam[0]);
       for (i=1; i<skd.nstation; i++){ printf("  %s",skd.statnam[i]); }
       printf("\n");
       printf("  My Station Name   :  %s (My Station ID : %s)\n",mystation,stat_id);
       printf("  Current Out Dir   :  %s    %.1fMB left\n",outdir,freeb/1.0e6);
       printf("  Next    Out Dir   :  %s    %.1fMB left\n",outdirtab.dir[ndir],freeb2/1.0e6);
       printf("  Total Scan Number :  %d\n",skd.nobs);

       printf("  1st Scan          :  %04d/%02d/%02d %02d:%02d:%02d  (%3dsec)  %s\n",
                      yearf,monthf,mdayf,hhf,mmf,ssf,skd.dura[0],skd.obsstar[0]);
       printf("  Last Scan         :  %04d/%02d/%02d %02d:%02d:%02d  (%3dsec)  %s\n",
                      yearl,monthl,mdayl,hhl,mml,ssl,skd.dura[skd.nobs-1],skd.obsstar[skd.nobs-1]);

       printf("  Obs Range (start) :  %04d/%02d/%02d %02d:%02d:%02d\n",
                      year1,month1,mday1,hh1,mm1,ss1);
       printf("  Obs Range (end)   :  %04d/%02d/%02d %02d:%02d:%02d\n",
                      year2,month2,mday2,hh2,mm2,ss2);
       printf("\n");

       printf("\033[2B");  // J[\ɂQs

       if(time_mode == 1) {
           if(ip_board_time(&day, &secnow, &hh, &mm, &ss)==-1) return -1 ;
           ddd=day;
           year=yearPC;
           ddd2md(year, ddd, &month, &mday);
       } else {
           getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset);
           secnow=hh*3600+mm*60+ss;
           md2ddd(year, &ddd, month, mday);
       }
       dtimenow=ddd+secnow/86400.0;
       printf("  Time Now (UTC)    :  %04d/%02d/%02d %02d:%02d:%02d\n\033[A",
                   year,month,mday,hh,mm,ss);
       printf("\033[2A");  // J[\ɂQs


       //fixspan=10;   // compulsory fix span length (sec)
       //nobs=0;
       //flagobs=0;
       while(1)
      {                                 // observation routine

           /* next observation start time get */
           yearn=skd.start[nobs][0]+2000;
           dddn=skd.start[nobs][1];
           hhn=skd.start[nobs][2];
           mmn=skd.start[nobs][3];
           ssn=skd.start[nobs][4];
           secnext=hhn*3600+mmn*60+ssn;
           daynext=dddn;
           //printf("daynext  %d\n",daynext);
           dtimenext=daynext+secnext/86400.0;
           ddd2md(yearn,dddn,&monthn,&mdayn);
           obsspan=skd.dura[nobs];
           dtimenext2=dtimenext+(double)obsspan/86400.0;
           
           /* disk capacity check */
           if (fixspan > obsspan || fixspan==0){
               span=obsspan; 
           } else {
               span=fixspan; 
           }
           if(strncmp(skd.obsstar[nobs],keyword,strlen(keyword))==0){          // 1ch obs     addded on 2003-03-13
                reqb=dsfreq*(double)adbit*(double)span;
           } else {
                reqb=dsfreq*(double)adbit*(double)span*(double)numch;
           }
           reqb/=8.0;   // in byte unit
           reqmb=reqb/1.0e6;
           freeb=GetFreeInfo(outdir);
           if(nobs == 1 && ndir==1) freeb=10.0e6;
           if(nobs == 3 && ndir==2) freeb=10.0e6;
           if(1.5*reqb > freeb){   //  out directory change
              if(ndir < outdirtab.dirnum){
                  strcpy(outdir,outdirtab.dir[ndir]);
                  ndir++;
                  sprintf(cbuf,"OUT directory changed  :  %s",outdir);
                  LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,0,cbuf);
                  goto obsloop;
              }
           }

           
           if(fixspan > obsspan || fixspan==0){
              printf("\033[2K  Next Scan(No.%04d):  %04d/%02d/%02d %02d:%02d:%02d  (%3dsec)  %s [%.1fMB]\n",
                      nobs+1,yearn,monthn,mdayn,hhn,mmn,ssn,obsspan,skd.obsstar[nobs],reqmb);
                       // \033[2K  means erases the entire current line
              sprintf(cbuf,"OBS# %04d :  %04d/%02d/%02d %02d:%02d:%02d  (%3dsec)  %s [%.1fMB]",
                      nobs+1,yearn,monthn,mdayn,hhn,mmn,ssn,obsspan,skd.obsstar[nobs],reqmb);
           } else {
              printf("\033[2K  Next Scan(No.%04d):  %04d/%02d/%02d %02d:%02d:%02d  (%3dsec ==>%3dsec)  %s [%.1fMB]\n",
                      nobs+1,yearn,monthn,mdayn,hhn,mmn,ssn,obsspan,fixspan,skd.obsstar[nobs], reqmb);
              sprintf(cbuf,"OBS# %04d :  %04d/%02d/%02d %02d:%02d:%02d  (%3dsec ==>%3dsec)  %s [%.1fMB]",
                      nobs+1,yearn,monthn,mdayn,hhn,mmn,ssn,obsspan,fixspan,skd.obsstar[nobs],reqmb);
           }
           printf("\n");
           LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,0,cbuf);
           
           
           
           
           /*
           if (dtimenow > dtimenext2 ) // next observation set
           {
              nobs++;
              printf("\033[2A");  // J[\ɂQs
              goto pass2;
           }
           */

       loop1:

           /* compare system time */
           usleep(SLEEP_USEC);
           //getsystime(&year, &month, &mday, &hh, &mm, &ss, &iofset);
           if(time_mode == 1) {
              if(ip_board_time(&day, &secnow, &hh, &mm, &ss)==-1) return -1 ;
              ddd=day;
              year=yearPC;
              ddd2md(year, ddd, &month, &mday);
           } else {
              getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset);
              secnow=hh*3600+mm*60+ss;
              md2ddd(year, &ddd, month, mday);
           }
           dtimenow=ddd+secnow/86400.0;
           //printf("Total Day  %d  %f\n", ddd, dtimenow); 
           if (dtime1 > dtimenext2 ) // next observation set
           {
              nobs++;
              if(nobs > skd.nobs) { goto exitend; }   // add on 2002/7/22
              printf("\033[2A");  // J[\ɂQs
              goto pass2;
           }
      	/*
           if (dtimenow < dtime1) { goto pass1; }
           if (dtimenow < dtime1st) { goto pass1; }
           if (dtimenow > dtime2) { goto exitend; }
           if (dtimenow > dtimelast) { goto exitend; }
           if (dtimenow >= dtimenext && dtimenow < dtimenext2 ) 
      	*/
      	   /*  for autoobs2 */
           if ((dtimenow+d1sec) < dtime1) { goto pass1; }
           if ((dtimenow+d1sec) < dtime1st) { goto pass1; }
           if (dtimenow > dtime2) { goto exitend; }
           if (dtimenow > dtimelast) { goto exitend; }
           if ((dtimenow+d1sec) >= dtimenext && dtimenow < dtimenext2 ) 
           { 
              /* sampling start */

              /* out file name creation */
              /*  Xdddnnn.dat   X-- satation id  ddd -- total day,  nnn -- obs number  */
              // sprintf(fname,"%1s%03d%03d.dat\0",stat_id,dddf,nobs+1);
              sprintf(fname,"%1s%03d%04d.dat\0",stat_id,dddf,nobs+1);  // for autoobs2
              strcpy(outfile,outdir);
              strcat(outfile,fname);
              //printf("%s\n",outfile);
              /* obsspan re-calc */
              //printf("obsspan   %d\n",obsspan);
              //dwork=(dtimenext2 - dtimenow)*86400.0;  // 2002-08-15
              dwork=(dtimenext2 - dtimenow-d1sec)*86400.0;  // 2002-08-15
              //obsspan=(int)dwork ;                      // 2002-08-15
              obsspan=nint(dwork) ;                      // 2002-08-15
              //printf("obsspan(after)   %d\n",obsspan);
              if (fixspan > obsspan || fixspan==0)
              {  span=obsspan; }
              else
              {  span=fixspan; }
              printf("\033[B");  // J[\ɂPs
              printf("OUT file name ==> %s\n",outfile);

              //if(strncmp(skd.obsstar[nobs],"NOZ",3)==0){          // 1ch obs     addded on 2003-03-13
              if(strncmp(skd.obsstar[nobs],keyword,strlen(keyword))==0){          // 1ch obs     addded on 2003-03-13
                 printf("NOZOMI mode!!  1ch sampling now\n");     // 2003-03-13
                 rv=sampleget(outfile, span, sfreq, adbit, 1);    // 2003-03-13
                 sprintf(cbuf,"NOZOMI mode!!  1ch sampled");     // 2003-06-16
                 LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);
                 sprintf(cbuf,"OBS# %04d : %s %d %d %d 1",nobs+1,outfile,span,sfreq,adbit);
              } else {                                            // 2003-03-13
                 rv=sampleget(outfile, span, sfreq, adbit, numch);
                 sprintf(cbuf,"OBS# %04d : %s %d %d %d %d",nobs+1,outfile,span,sfreq,adbit,numch);
              }                                                   // 2003-03-13
           
              LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,1,cbuf);
              
           	
              nobs++;
              //printf("\033[A\033[A");  // J[\ɂQs
              //goto pass2;
              goto obsloop;
           
           }
           if (dtimenow > dtimenext2 ) // next observation set
           {
              nobs++;
              printf("\033[2A");  // J[\ɂQs
              goto pass2;
           }

       pass1:
           if (secnow != secold)
           {
             printf("  Time Now (UTC)    :  %04d/%02d/%02d %02d:%02d:%02d\n\033[A",
                      year,month,mday,hh,mm,ss);
           }
           secold=secnow; 
           goto loop1;
        pass2:;

       }

  exitend:

       printf("\n\n"); 
       
       sprintf(cbuf,"*********** AUTOOBS_S OBSERVATION END **************");
       LogWrite3(logdir,hostname,logfile,logfiletype,time_mode,0.0,2,cbuf);


       return 0;
}

